<script setup lang="ts">
import { computed, onMounted } from 'vue';
import SdgButton from '../components/SdgButton.vue';
import SdgSpinner from '../components/SdgSpinner.vue';
import { useGameStore } from '../stores/gameStore';
import { useRouter } from 'vue-router';
import { useFirebaseStore } from '../stores/firebaseStore';
import ImageFlipperBlock from '@/components/ImageFlipperBlock.vue';

const gameStore = useGameStore();
const firebaseStore = useFirebaseStore();
const router = useRouter();

const people = ['adam_johnson', 'anh_duong', 'ben_fischer', 'ben_stori', 'gucci_aguh', 'kate_williamson', 'lindsey_hansen', 'nick_bruecken', 'cooper_miller'];

const disabled = computed(() => {
  return gameStore.loading;
});

const isAdmin = computed(() => {
  return firebaseStore.admins.some((x) => x.id === gameStore.currentUser.id);
});
onMounted(async function () {
  if (!gameStore.loaded) {
    gameStore.setLoading(true);
    await gameStore.loadData();
    gameStore.setLoading(false);
  }
});

const hasSpinner = computed(() => gameStore.loading);

const onClick = () => {
  router.push({ name: 'panel' });
};

const onAdmin = () => {
  router.push({ name: 'admin' });
};

const onCampaign = () => {
  router.push({ name: 'updateDataCampaign' });
};
</script>

<template>
  <div class="w-full h-full p-4 sdg-background-light-grey flex justify-center items-center">
    <div class="text-center">
      <h1 class="text-6xl text-sdg-blue text-sdg">Welcome to SDG People!</h1>
      <p class="text-2xl text-sdg-gray my-4">The game where you learn who's who at SDG.</p>
      <div v-if="gameStore.errored" class="text-red-500 border border-red-500 p-2">
        <h2 class="text-lg font-semibold">Microsoft authorization failed.</h2>
        <p class="text-sm">Please set your browser to allow popups, and reload the page.</p>
      </div>
      <div v-else>
        <div v-if="hasSpinner" class="text-center my-2">
          <SdgSpinner />
        </div>
        <div v-if="!hasSpinner">
          <SdgButton :disabled="disabled" color="bg-sdg-blue" @onClick="onClick">
            <span class="text-white font-thin">Let’s Play! →</span>
          </SdgButton>
          <SdgButton v-if="isAdmin" :disabled="disabled" class="ml-4" color="bg-sdg-blue" @onClick="onAdmin">
            <span class="text-white font-thin">Admin</span>
          </SdgButton>
          <SdgButton v-if="isAdmin" :disabled="disabled" class="ml-4" color="bg-sdg-blue" @onClick="onCampaign">
            <span class="text-white font-thin">Manage Data Campaigns</span>
          </SdgButton>
        </div>
      </div>
      <ImageFlipperBlock :people="people" class="my-8" />
      <p class="text-sdg-gray text-xl">Produced by your fellow SDG'ers!</p>
    </div>
  </div>
</template>
<style scoped>
img {
  border: 4 px rgba(0, 0, 0, 0.2);
  background: #fff;
  border-radius: 50%;
  padding: 2px;
  width: 175px;
}
</style>
